from django.contrib.staticfiles.testing import StaticLiveServerTestCase
from recuperateur_reseau_viaire.models import Graph_viaire_ville_information, Ville, Rassemblement_ville
from selenium.webdriver.firefox.webdriver import WebDriver


class update_gvvi_formulaireTests(StaticLiveServerTestCase):

    selenium = None

    @classmethod
    def setUpClass(cls):
        """
        Le but de cette méthode est d'initialiser selenium avant le début des tests de la classe

        """
        super().setUpClass()
        cls.selenium = WebDriver()
        cls.selenium.implicitly_wait(10)

    @classmethod
    def tearDownClass(cls):
        """
        Le but de cette méthode est de fermer selenium à la fin des tests de la classe
        """
        cls.selenium.quit()
        super().tearDownClass()

    def setUp(self) -> None:
        """
        Le but de cette méthode est que selenium soit dans l'index du site à chaque test
        """
        self.nom_ville_test_a = "commune"
        self.nom_ville_test_b = "ville"

        def ajoute_ville_et_gvvi(nom_ville):
            """
            Le but de cette méthode est de créer une instance ville de nom nom ville et une instance
            Graph_viaire_ville_information ayant pour ville la ville créé.
            :param nom_ville: nom de la ville à créer
            """
            Ville.objects.create(ville_nom=nom_ville)
            Graph_viaire_ville_information.objects.create(gvvi_cout=0, gvvi_robustesse=0,
                                                          gvvi_d2_correlation_dimension=0,
                                                          gvvi_d1_information_dimension=0,
                                                          gvvi_d0_fractal_capacite_dimension=0,
                                                          gvvi_longueur_moyenne_rues=0, gvvi_tree_vs_complete_graph=0,
                                                          gvvi_org_plan_vs_organized=0, gvvi_connectivity=0,
                                                          gvvi_degre_moyen=0, gvvi_diametre=0, gvvi_nb_intersection=0,
                                                          ville=Ville.objects.get(ville_nom=nom_ville))

        # création d'une instance de Ville
        ajoute_ville_et_gvvi(self.nom_ville_test_a)
        ajoute_ville_et_gvvi(self.nom_ville_test_b)
        Rassemblement_ville.objects.create(ville_englobante=Ville.objects.get(ville_nom=self.nom_ville_test_a),
                                           ville=Ville.objects.get(ville_nom=self.nom_ville_test_b))
        self.selenium.get('%s%s' % (self.live_server_url, '/recuperateur_reseau_viaire/'))